'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  var t = babel.types;


  return {
    name: "ast-transform", // not required
    visitor: {
      JSXElement: function JSXElement(path) {
        var element = path.node && path.node.openingElement && path.node.openingElement.name;

        if (!element) {
          return;
        }

        switch (element.name) {
          case 'view':
          case 'col':
          case 'row':
          case 'flex':
            convertFlex(t, path.node, element.name);
            break;
          case 'space':
            convertSpace(t, path.node);
            break;
          case 'text':
            convertText(t, path.node);
            break;
        }
      }
    }
  };
};

// const printAST = require('ast-pretty-print')
var convertFlex = require('./flex').default;
var convertSpace = require('./space').default;
var convertText = require('./text').default;