'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildDefaultCssProp = buildDefaultCssProp;
exports.addTemplateToTemplate = addTemplateToTemplate;
exports.addStringToTemplate = addStringToTemplate;
exports.addQuasiToTemplate = addQuasiToTemplate;
exports.addExpressionToTemplate = addExpressionToTemplate;
exports.renameTag = renameTag;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// const printAST = require('ast-pretty-print')

function buildDefaultCssProp(t, css) {
  return t.jSXAttribute(t.jSXIdentifier('css'), t.jSXExpressionContainer(t.templateLiteral([t.templateElement({
    raw: css,
    cooked: css
  })], [])));
}

function addTemplateToTemplate(target, template) {
  if (template.expressions.length > 0) {
    if (target.expressions.length === target.quasis.length) {
      var _target$expressions, _target$quasis;

      // safe to just push these
      (_target$expressions = target.expressions).push.apply(_target$expressions, _toConsumableArray(template.expressions));
      (_target$quasis = target.quasis).push.apply(_target$quasis, _toConsumableArray(template.quasis));
    } else {
      var _target$expressions2, _target$quasis2;

      (_target$expressions2 = target.expressions).push.apply(_target$expressions2, _toConsumableArray(template.expressions));

      // concate the first quasi, then push on the rest
      addStringToTemplate(target, template.quasis[0].value.raw);
      (_target$quasis2 = target.quasis).push.apply(_target$quasis2, _toConsumableArray(template.quasis.slice(1)));
    }
  } else {
    addStringToTemplate(target, template.quasis[0].value.raw);
  }
}

function addStringToTemplate(template, str) {
  var last = template.quasis.length - 1;

  template.quasis[last].value.raw = template.quasis[last].value.raw + str;
  template.quasis[last].value.cooked = template.quasis[last].value.cooked + str;
}

function addQuasiToTemplate(template, quasi) {
  template.quasis.push(quasi);
}

function addExpressionToTemplate(template, expression) {
  template.expressions.push(expression);
}

function renameTag(node) {
  var defaultTag = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'div';

  var tagName = defaultTag;

  if (node.openingElement.attributes != null) {
    var name = node.openingElement.attributes.find(function (prop) {
      return prop.name.name === 'as';
    });

    if (name !== undefined) {
      var val = name.value.value || name.value.expression.value;

      if (val != null) {
        tagName = val;
      } else {
        console.log('invalid `as` value. No variables allowed.');
      }
    }
  }

  node.openingElement.name.name = tagName;

  if (node.closingElement) {
    node.closingElement.name.name = tagName;
  }
}